/* $Id: virtual_x86.h,v 1.1 2004/01/11 22:07:23 mikpe Exp $
 * x86-specific code for virtual per-process performance counters.
 *
 * Copyright (C) 1999-2004  Mikael Pettersson
 */
#ifndef __VIRTUAL_X86_H
#define __VIRTUAL_X86_H

#define PAGE_SIZE	4096

#define rdtscl(low)	\
	__asm__ __volatile__("rdtsc" : "=a"(low) : : "edx")
#define rdpmcl(ctr,low)	\
	__asm__ __volatile__("rdpmc" : "=a"(low) : "c"(ctr) : "edx")

#if defined(__x86_64__)
#define vperfctr_has_rdpmc(vperfctr)	(1)
#else
#define vperfctr_has_rdpmc(vperfctr)	((vperfctr)->have_rdpmc)
#endif

#endif /* __VIRTUAL_X86_H */
